
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Training Colab &#8212; Battery SOH  documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    <link rel="stylesheet" type="text/css" href="../_static/css/custom.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <script async="async" src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-mml-chtml.js"></script>
    <script>window.MathJax = {"tex": {"inlineMath": [["$", "$"], ["\\(", "\\)"]], "processEscapes": true}, "options": {"ignoreHtmlClass": "tex2jax_ignore|mathjax_ignore|document", "processHtmlClass": "tex2jax_process|mathjax_process|math|output_area"}}</script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
              
              <div class="toc-item">
                

<nav id="bd-toc-nav">
    
</nav>
              </div>
              
              <div class="toc-item">
                
              </div>
              
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  
<style>
/* CSS for nbsphinx extension */

/* remove conflicting styling from Sphinx themes */
div.nbinput.container div.prompt *,
div.nboutput.container div.prompt *,
div.nbinput.container div.input_area pre,
div.nboutput.container div.output_area pre,
div.nbinput.container div.input_area .highlight,
div.nboutput.container div.output_area .highlight {
    border: none;
    padding: 0;
    margin: 0;
    box-shadow: none;
}

div.nbinput.container > div[class*=highlight],
div.nboutput.container > div[class*=highlight] {
    margin: 0;
}

div.nbinput.container div.prompt *,
div.nboutput.container div.prompt * {
    background: none;
}

div.nboutput.container div.output_area .highlight,
div.nboutput.container div.output_area pre {
    background: unset;
}

div.nboutput.container div.output_area div.highlight {
    color: unset;  /* override Pygments text color */
}

/* avoid gaps between output lines */
div.nboutput.container div[class*=highlight] pre {
    line-height: normal;
}

/* input/output containers */
div.nbinput.container,
div.nboutput.container {
    display: -webkit-flex;
    display: flex;
    align-items: flex-start;
    margin: 0;
    width: 100%;
}
@media (max-width: 540px) {
    div.nbinput.container,
    div.nboutput.container {
        flex-direction: column;
    }
}

/* input container */
div.nbinput.container {
    padding-top: 5px;
}

/* last container */
div.nblast.container {
    padding-bottom: 5px;
}

/* input prompt */
div.nbinput.container div.prompt pre {
    color: #307FC1;
}

/* output prompt */
div.nboutput.container div.prompt pre {
    color: #BF5B3D;
}

/* all prompts */
div.nbinput.container div.prompt,
div.nboutput.container div.prompt {
    width: 4.5ex;
    padding-top: 5px;
    position: relative;
    user-select: none;
}

div.nbinput.container div.prompt > div,
div.nboutput.container div.prompt > div {
    position: absolute;
    right: 0;
    margin-right: 0.3ex;
}

@media (max-width: 540px) {
    div.nbinput.container div.prompt,
    div.nboutput.container div.prompt {
        width: unset;
        text-align: left;
        padding: 0.4em;
    }
    div.nboutput.container div.prompt.empty {
        padding: 0;
    }

    div.nbinput.container div.prompt > div,
    div.nboutput.container div.prompt > div {
        position: unset;
    }
}

/* disable scrollbars on prompts */
div.nbinput.container div.prompt pre,
div.nboutput.container div.prompt pre {
    overflow: hidden;
}

/* input/output area */
div.nbinput.container div.input_area,
div.nboutput.container div.output_area {
    -webkit-flex: 1;
    flex: 1;
    overflow: auto;
}
@media (max-width: 540px) {
    div.nbinput.container div.input_area,
    div.nboutput.container div.output_area {
        width: 100%;
    }
}

/* input area */
div.nbinput.container div.input_area {
    border: 1px solid #e0e0e0;
    border-radius: 2px;
    /*background: #f5f5f5;*/
}

/* override MathJax center alignment in output cells */
div.nboutput.container div[class*=MathJax] {
    text-align: left !important;
}

/* override sphinx.ext.imgmath center alignment in output cells */
div.nboutput.container div.math p {
    text-align: left;
}

/* standard error */
div.nboutput.container div.output_area.stderr {
    background: #fdd;
}

/* ANSI colors */
.ansi-black-fg { color: #3E424D; }
.ansi-black-bg { background-color: #3E424D; }
.ansi-black-intense-fg { color: #282C36; }
.ansi-black-intense-bg { background-color: #282C36; }
.ansi-red-fg { color: #E75C58; }
.ansi-red-bg { background-color: #E75C58; }
.ansi-red-intense-fg { color: #B22B31; }
.ansi-red-intense-bg { background-color: #B22B31; }
.ansi-green-fg { color: #00A250; }
.ansi-green-bg { background-color: #00A250; }
.ansi-green-intense-fg { color: #007427; }
.ansi-green-intense-bg { background-color: #007427; }
.ansi-yellow-fg { color: #DDB62B; }
.ansi-yellow-bg { background-color: #DDB62B; }
.ansi-yellow-intense-fg { color: #B27D12; }
.ansi-yellow-intense-bg { background-color: #B27D12; }
.ansi-blue-fg { color: #208FFB; }
.ansi-blue-bg { background-color: #208FFB; }
.ansi-blue-intense-fg { color: #0065CA; }
.ansi-blue-intense-bg { background-color: #0065CA; }
.ansi-magenta-fg { color: #D160C4; }
.ansi-magenta-bg { background-color: #D160C4; }
.ansi-magenta-intense-fg { color: #A03196; }
.ansi-magenta-intense-bg { background-color: #A03196; }
.ansi-cyan-fg { color: #60C6C8; }
.ansi-cyan-bg { background-color: #60C6C8; }
.ansi-cyan-intense-fg { color: #258F8F; }
.ansi-cyan-intense-bg { background-color: #258F8F; }
.ansi-white-fg { color: #C5C1B4; }
.ansi-white-bg { background-color: #C5C1B4; }
.ansi-white-intense-fg { color: #A1A6B2; }
.ansi-white-intense-bg { background-color: #A1A6B2; }

.ansi-default-inverse-fg { color: #FFFFFF; }
.ansi-default-inverse-bg { background-color: #000000; }

.ansi-bold { font-weight: bold; }
.ansi-underline { text-decoration: underline; }


div.nbinput.container div.input_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight].math,
div.nboutput.container div.output_area.rendered_html,
div.nboutput.container div.output_area > div.output_javascript,
div.nboutput.container div.output_area:not(.rendered_html) > img{
    padding: 5px;
    margin: 0;
}

/* fix copybtn overflow problem in chromium (needed for 'sphinx_copybutton') */
div.nbinput.container div.input_area > div[class^='highlight'],
div.nboutput.container div.output_area > div[class^='highlight']{
    overflow-y: hidden;
}

/* hide copybtn icon on prompts (needed for 'sphinx_copybutton') */
.prompt a.copybtn {
    display: none;
}

/* Some additional styling taken form the Jupyter notebook CSS */
div.rendered_html table {
  border: none;
  border-collapse: collapse;
  border-spacing: 0;
  color: black;
  font-size: 12px;
  table-layout: fixed;
}
div.rendered_html thead {
  border-bottom: 1px solid black;
  vertical-align: bottom;
}
div.rendered_html tr,
div.rendered_html th,
div.rendered_html td {
  text-align: right;
  vertical-align: middle;
  padding: 0.5em 0.5em;
  line-height: normal;
  white-space: normal;
  max-width: none;
  border: none;
}
div.rendered_html th {
  font-weight: bold;
}
div.rendered_html tbody tr:nth-child(odd) {
  background: #f5f5f5;
}
div.rendered_html tbody tr:hover {
  background: rgba(66, 165, 245, 0.2);
}
</style>
<div class="section" id="Training-Colab">
<h1><strong>Training Colab</strong><a class="headerlink" href="#Training-Colab" title="Permalink to this headline">¶</a></h1>
<p>This Colab serves for model training. For it to work, a folder called <code class="docutils literal notranslate"><span class="pre">battery_soh</span></code> must be created on google drive and include another folder called <code class="docutils literal notranslate"><span class="pre">Battery_SOH_</span></code> + the date of the most current version (<code class="docutils literal notranslate"><span class="pre">day_month</span></code>). This <code class="docutils literal notranslate"><span class="pre">Battery_SOH</span></code> should contain all of the necessary files (<code class="docutils literal notranslate"><span class="pre">Pytorch_Dataset.py</span></code>, <code class="docutils literal notranslate"><span class="pre">Training.py</span></code>, <code class="docutils literal notranslate"><span class="pre">NN_Classes.py</span></code>, <code class="docutils literal notranslate"><span class="pre">Nasa_Classes.py</span></code> and the dataset files).</p>
<p>An example can be found in the following google drive link (you’ll need to ask for access): <a class="reference external" href="https://drive.google.com/drive/folders/1G5xLrXHlKq3QpOzaFGusB89_erZPYwa6?usp=sharing">https://drive.google.com/drive/folders/1G5xLrXHlKq3QpOzaFGusB89_erZPYwa6?usp=sharing</a></p>
<p>The following cell includes the bare minimum to mount google drive to google colab so that the files can be directly called. The <code class="docutils literal notranslate"><span class="pre">root_path</span></code> may have to be updated to the latest <code class="docutils literal notranslate"><span class="pre">Battery_SOH</span></code> folder.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[1]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">google.colab</span> <span class="kn">import</span> <span class="n">drive</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">torch</span> <span class="k">as</span> <span class="nn">th</span>

<span class="c1"># Mounting google drivee</span>
<span class="n">drive</span><span class="o">.</span><span class="n">mount</span><span class="p">(</span><span class="s1">&#39;/content/gdrive&#39;</span><span class="p">)</span>
<span class="n">folder_name</span> <span class="o">=</span> <span class="s1">&#39;Battery_SOH_02_06_14h&#39;</span>
<span class="c1"># The root path will change depending on the latest &#39;bakcup&#39;</span>
<span class="n">root_path</span> <span class="o">=</span> <span class="s1">&#39;gdrive/My Drive/battery_soh/&#39;</span><span class="o">+</span><span class="n">folder_name</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="n">root_path</span><span class="p">)</span>
<span class="n">device</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">device</span><span class="p">(</span><span class="s1">&#39;cuda:0&#39;</span> <span class="k">if</span> <span class="n">th</span><span class="o">.</span><span class="n">cuda</span><span class="o">.</span><span class="n">is_available</span><span class="p">()</span> <span class="k">else</span> <span class="s1">&#39;cpu&#39;</span><span class="p">)</span>
<span class="n">device</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Mounted at /content/gdrive
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[1]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
device(type=&#39;cpu&#39;)
</pre></div></div>
</div>
<p>The cell should output something like:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>Mounted at /content/gdrive
device(type=&#39;cuda&#39;, index=0)
</pre></div>
</div>
<p>If the second line says <code class="docutils literal notranslate"><span class="pre">device(type='cpu')</span></code> then you should change your environment options above for GPU for faster results.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[2]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span>!pip install PyAstronomy
from FFNN import *
from torch.utils.data import DataLoader
from Training import *
import re
from datetime import datetime
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Collecting PyAstronomy
  Downloading https://files.pythonhosted.org/packages/1f/d7/251cbad869abf5834b5bbc1012f76831dfbbf34d60677598dd542ef003ce/PyAstronomy-0.16.0.tar.gz (711kB)
     |████████████████████████████████| 716kB 5.1MB/s
Requirement already satisfied: numpy in /usr/local/lib/python3.7/dist-packages (from PyAstronomy) (1.19.5)
Requirement already satisfied: six in /usr/local/lib/python3.7/dist-packages (from PyAstronomy) (1.15.0)
Building wheels for collected packages: PyAstronomy
  Building wheel for PyAstronomy (setup.py) ... done
  Created wheel for PyAstronomy: filename=PyAstronomy-0.16.0-cp37-none-any.whl size=504499 sha256=e1bcfd41f2fa96cb0e4e975093ded427150a9b26d61f1e35eb6fdb6858a763e4
  Stored in directory: /root/.cache/pip/wheels/93/af/aa/931d34dfc98c7f7fb4514fb9da32cac3584895cc03e873bdd1
Successfully built PyAstronomy
Installing collected packages: PyAstronomy
Successfully installed PyAstronomy-0.16.0
</pre></div></div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1">#os.chdir(&#39;../&#39;)</span>
<span class="c1">#os.listdir()</span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[13]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Datasets/NASA/B. Saha and K Goebel&#39;</span><span class="p">)</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Separate_pickles&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[4]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="n">Nb_clusters</span> <span class="o">=</span> <span class="mi">80</span>
</pre></div>
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[5]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># K-MEANS:</span>
<span class="k">try</span><span class="p">:</span>  <span class="c1"># If a K-means clustering has already been done with</span>
    <span class="c1"># that number of clusters:</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;kmeans&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">Nb_clusters</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39;.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="n">kmeans</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="k">except</span> <span class="ne">FileNotFoundError</span><span class="p">:</span>  <span class="c1"># If not:</span>

    <span class="c1"># Opening the complete, clean, IVT data:</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;IVT_Data.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="n">IVT</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
    <span class="n">IVT</span> <span class="o">=</span> <span class="n">IVT</span><span class="o">.</span><span class="n">detach</span><span class="p">()</span><span class="o">.</span><span class="n">numpy</span><span class="p">()</span>  <span class="c1"># Converting to numpy</span>

    <span class="c1"># The actual kmeans clustering:</span>
    <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Starting k-means...&#39;</span><span class="p">)</span>
    <span class="n">start</span> <span class="o">=</span> <span class="n">time</span><span class="o">.</span><span class="n">time</span><span class="p">()</span>
    <span class="n">kmeans</span> <span class="o">=</span> <span class="n">KMeans</span><span class="p">(</span><span class="n">n_clusters</span><span class="o">=</span><span class="n">Nb_clusters</span><span class="p">)</span><span class="o">.</span><span class="n">fit</span><span class="p">(</span><span class="n">IVT</span><span class="p">)</span>
    <span class="n">end</span> <span class="o">=</span> <span class="n">time</span><span class="o">.</span><span class="n">time</span><span class="p">()</span>
    <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Finished: &#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">Nb_clusters</span><span class="p">)</span> <span class="o">+</span>
            <span class="s1">&#39; cluster k-means in &#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">end</span> <span class="o">-</span> <span class="n">start</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39; seconds&#39;</span><span class="p">)</span>

    <span class="c1"># Saving the class:</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;kmeans&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">Nb_clusters</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39;.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;wb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="n">pickle</span><span class="o">.</span><span class="n">dump</span><span class="p">(</span><span class="n">kmeans</span><span class="p">,</span> <span class="n">f</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area stderr docutils container">
<div class="highlight"><pre>
/usr/local/lib/python3.7/dist-packages/sklearn/base.py:318: UserWarning: Trying to unpickle estimator KMeans from version 0.24.1 when using version 0.22.2.post1. This might lead to breaking code or invalid results. Use at your own risk.
  UserWarning)
</pre></div></div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[6]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="n">batch_size</span> <span class="o">=</span> <span class="mi">1</span>
<span class="n">mean_hist</span><span class="o">=</span><span class="kc">True</span>
<span class="n">norm_type</span> <span class="o">=</span> <span class="s1">&#39;zscore&#39;</span>
<span class="n">resampling</span> <span class="o">=</span> <span class="kc">True</span>
<span class="n">fixed_len</span> <span class="o">=</span> <span class="mi">150</span>
</pre></div>
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[16]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="n">files</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">()</span>  <span class="c1"># All files in the folder</span>
<span class="n">file_list</span> <span class="o">=</span> <span class="p">[]</span>  <span class="c1"># List with the valid files</span>
<span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">files</span><span class="p">:</span>
    <span class="n">match</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">search</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;B\d</span><span class="si">{4}</span><span class="s1">.txt&#39;</span><span class="p">,</span> <span class="n">file_name</span><span class="p">)</span>  <span class="c1"># Only take into acount</span>
    <span class="c1"># the battery files</span>
    <span class="k">if</span> <span class="n">match</span> <span class="o">==</span> <span class="kc">None</span><span class="p">:</span>
        <span class="k">continue</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">file_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">file_name</span><span class="p">)</span>
<span class="n">file_list</span><span class="o">.</span><span class="n">sort</span><span class="p">()</span>


<span class="c1"># Files to be ignored:</span>
<span class="n">ignore</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;B0049.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0050.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0051.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0052.txt&#39;</span><span class="p">,</span>
          <span class="s1">&#39;B0025.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0026.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0027.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0028.txt&#39;</span><span class="p">,</span>
          <span class="s1">&#39;B0029.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0030.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0031.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0032.txt&#39;</span><span class="p">,</span>
          <span class="s1">&#39;B0038.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0039.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0040.txt&#39;</span><span class="p">]</span>


<span class="n">train</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;B0034.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0036.txt&#39;</span><span class="p">,</span>
         <span class="s1">&#39;B0007.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0018.txt&#39;</span><span class="p">,</span>
         <span class="s1">&#39;B0045.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0046.txt&#39;</span><span class="p">,</span>
         <span class="s1">&#39;B0053.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0054.txt&#39;</span><span class="p">]</span>


<span class="c1"># with open(&#39;train_dataset_FFNN_&#39;+norm_name+&#39;.txt&#39;, &#39;rb&#39;) as f:</span>
<span class="c1">#     train_dataset, valid_dataset = pickle.load(f)</span>

<span class="c1"># Training files:</span>
<span class="n">Train_list</span> <span class="o">=</span> <span class="p">[]</span>
<span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
    <span class="k">if</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">train</span><span class="p">:</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
        <span class="n">Train_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Battery</span><span class="p">)</span>

<span class="c1"># Creating the dataset:</span>
<span class="n">train_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_KMEANS</span><span class="p">(</span><span class="n">Train_list</span><span class="p">,</span> <span class="n">Nb_clusters</span><span class="p">,</span> <span class="n">kmeans</span><span class="o">=</span><span class="n">kmeans</span><span class="p">,</span>
                                     <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">norm_type</span><span class="o">=</span><span class="n">norm_type</span><span class="p">,</span>
                                     <span class="n">mean_hist</span><span class="o">=</span><span class="n">mean_hist</span><span class="p">,</span> <span class="n">resampling</span><span class="o">=</span><span class="n">resampling</span><span class="p">,</span>
                                     <span class="n">fixed_len</span><span class="o">=</span><span class="n">fixed_len</span><span class="p">)</span>

<span class="n">train_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">train_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="n">batch_size</span><span class="p">,</span> <span class="n">shuffle</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">num_workers</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>

<span class="n">sim_train_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">train_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="nb">len</span><span class="p">(</span><span class="n">train_dataset</span><span class="p">),</span> <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">num_workers</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>

<span class="c1"># Validation files:</span>
<span class="n">Valid_list</span> <span class="o">=</span> <span class="p">[]</span>
<span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
    <span class="k">if</span> <span class="p">(</span><span class="n">file_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">train</span><span class="p">)</span> <span class="ow">and</span> <span class="p">(</span><span class="n">file_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">ignore</span><span class="p">):</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
        <span class="n">Valid_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Battery</span><span class="p">)</span>

<span class="n">valid_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_KMEANS</span><span class="p">(</span><span class="n">Valid_list</span><span class="p">,</span> <span class="n">Nb_clusters</span><span class="p">,</span> <span class="n">kmeans</span><span class="o">=</span><span class="n">kmeans</span><span class="p">,</span>
                                     <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">norm</span><span class="o">=</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">norm</span><span class="p">,</span>
                                     <span class="n">mean_hist</span><span class="o">=</span><span class="n">mean_hist</span><span class="p">,</span> <span class="n">resampling</span><span class="o">=</span><span class="n">resampling</span><span class="p">,</span>
                                     <span class="n">fixed_len</span><span class="o">=</span><span class="n">fixed_len</span><span class="p">)</span>

<span class="c1"># with open(&#39;train_dataset_FFNN_&#39;+norm_name+&#39;_&#39;+str(batch_size)+&#39;.txt&#39;, &#39;wb&#39;) as f:</span>
<span class="c1">#     pickle.dump((train_dataset, valid_dataset), f)</span>

<span class="n">valid_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">valid_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="nb">len</span><span class="p">(</span><span class="n">valid_dataset</span><span class="p">),</span> <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">num_workers</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0007
B0018
B0034
B0036
B0045
B0046
B0053
B0054
973
B0005
B0006
B0033
B0041
B0042
B0043
B0044
B0047
B0048
B0055
B0056
1052
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[18]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="n">HIDDEN_DIM</span> <span class="o">=</span> <span class="mi">80</span>
<span class="n">DROPOUT</span> <span class="o">=</span> <span class="mi">0</span>
<span class="n">Nb_Epochs</span> <span class="o">=</span> <span class="mi">500</span>
<span class="n">Learning_Rate</span> <span class="o">=</span> <span class="mf">0.5</span><span class="o">*</span><span class="mf">1e-5</span>

<span class="n">Model</span> <span class="o">=</span> <span class="n">FFNN_v1</span><span class="p">(</span><span class="n">Nb_clusters</span><span class="p">,</span> <span class="n">HIDDEN_DIM</span><span class="p">,</span> <span class="n">drop_out</span><span class="o">=</span><span class="n">DROPOUT</span><span class="p">,</span> <span class="n">norm</span><span class="o">=</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">norm</span><span class="p">,</span>
                <span class="n">mean_hist</span> <span class="o">=</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">mean_hist</span><span class="p">)</span>

<span class="n">simulate</span><span class="p">(</span><span class="n">sim_train_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">block</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">block</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_11_0.png" src="../_images/Google_Colabs_Battery_SOH_K_means_11_0.png" />
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_11_1.png" src="../_images/Google_Colabs_Battery_SOH_K_means_11_1.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[24]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">getcwd</span><span class="p">()</span> <span class="o">==</span> <span class="s1">&#39;/content/gdrive/My Drive/battery_soh/&#39;</span><span class="o">+</span><span class="n">folder_name</span><span class="o">+</span><span class="s1">&#39;/Datasets/NASA/B. Saha and K Goebel/Separate_pickles&#39;</span><span class="p">:</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../../../&#39;</span><span class="p">)</span>
<span class="k">elif</span> <span class="n">os</span><span class="o">.</span><span class="n">getcwd</span><span class="p">()</span> <span class="o">!=</span> <span class="s1">&#39;/content/gdrive/My Drive/battery_soh/&#39;</span><span class="o">+</span><span class="n">folder_name</span><span class="p">:</span>
    <span class="nb">print</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">())</span>
    <span class="k">raise</span> <span class="ne">Exception</span><span class="p">(</span><span class="s1">&#39;Folder problem&#39;</span><span class="p">)</span>

<span class="n">Train_info</span><span class="p">,</span> <span class="n">_</span> <span class="p">,</span> <span class="n">_</span> <span class="o">=</span> <span class="n">Train</span><span class="p">(</span><span class="n">train_loader</span><span class="p">,</span> <span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">Nb_Epochs</span><span class="p">,</span> <span class="n">plot_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">LR</span><span class="o">=</span><span class="n">Learning_Rate</span><span class="p">,</span> <span class="n">report</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                          <span class="n">sim_loader</span><span class="o">=</span><span class="n">sim_train_loader</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>


<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Datasets/NASA/B. Saha and K Goebel&#39;</span><span class="p">)</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Separate_pickles&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_12_0.png" src="../_images/Google_Colabs_Battery_SOH_K_means_12_0.png" />
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Best validation error:  42
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[25]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Best model</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">sim_train_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">block</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">block</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_13_0.png" src="../_images/Google_Colabs_Battery_SOH_K_means_13_0.png" />
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_13_1.png" src="../_images/Google_Colabs_Battery_SOH_K_means_13_1.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[26]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">getcwd</span><span class="p">()</span> <span class="o">==</span> <span class="s1">&#39;/content/gdrive/My Drive/battery_soh/&#39;</span><span class="o">+</span><span class="n">folder_name</span><span class="o">+</span><span class="s1">&#39;/Datasets/NASA/B. Saha and K Goebel/Separate_pickles&#39;</span><span class="p">:</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../../../&#39;</span><span class="p">)</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Reports&#39;</span><span class="p">)</span>
<span class="k">elif</span> <span class="n">os</span><span class="o">.</span><span class="n">getcwd</span><span class="p">()</span> <span class="o">!=</span> <span class="s1">&#39;/content/gdrive/My Drive/battery_soh/&#39;</span><span class="o">+</span><span class="n">folder_name</span><span class="o">+</span><span class="s1">&#39;/Reports&#39;</span><span class="p">:</span>
    <span class="nb">print</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">())</span>
    <span class="k">raise</span> <span class="ne">Exception</span><span class="p">(</span><span class="s1">&#39;Folder problem&#39;</span><span class="p">)</span>

<span class="n">file_name</span> <span class="o">=</span> <span class="nb">input</span><span class="p">(</span><span class="s2">&quot;Report folder: &quot;</span><span class="p">)</span>
<span class="n">file_name</span> <span class="o">=</span> <span class="n">file_name</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s1">&#39;/&#39;</span><span class="p">,</span> <span class="s1">&#39;:&#39;</span><span class="p">)</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">file_name</span><span class="p">))</span>

<span class="n">Train_info</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="nb">open</span><span class="p">(</span><span class="s1">&#39;Training_Info.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">))</span>

<span class="k">try</span><span class="p">:</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;base_model.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="n">Model</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>

<span class="k">except</span> <span class="ne">FileNotFoundError</span><span class="p">:</span>
    <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;problem&#39;</span><span class="p">)</span>

<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../&#39;</span><span class="p">)</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Datasets/NASA/B. Saha and K Goebel&#39;</span><span class="p">)</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Separate_pickles&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Report folder: 2021-06-02 15:14:07.099891
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[27]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Last_model</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">sim_train_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">block</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="n">simulate</span><span class="p">(</span><span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">block</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_15_0.png" src="../_images/Google_Colabs_Battery_SOH_K_means_15_0.png" />
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_15_1.png" src="../_images/Google_Colabs_Battery_SOH_K_means_15_1.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[28]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1">#Name_list = [str(Battery.Name)+&#39;.txt&#39; for Battery in Train_list]</span>
<span class="n">Name_list</span> <span class="o">=</span> <span class="n">train</span>

<span class="n">ignore2</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;B0049.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0050.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0051.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0052.txt&#39;</span><span class="p">]</span>

<span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
    <span class="k">if</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">ignore</span><span class="p">:</span>
        <span class="k">continue</span>
    <span class="k">if</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">Name_list</span><span class="p">:</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39; (used in training)&#39;</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">file_name</span><span class="p">)</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>

    <span class="n">Battery_list</span> <span class="o">=</span> <span class="p">[</span><span class="n">Battery</span><span class="p">]</span>
    <span class="n">th_B</span> <span class="o">=</span> <span class="n">Torch_Dataset_KMEANS</span><span class="p">(</span><span class="n">Battery_list</span><span class="p">,</span> <span class="n">Nb_clusters</span><span class="p">,</span> <span class="n">kmeans</span><span class="o">=</span><span class="n">kmeans</span><span class="p">,</span>
                                <span class="n">print_bool</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">norm</span><span class="o">=</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">norm</span><span class="p">,</span>
                                <span class="n">mean_hist</span> <span class="o">=</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">mean_hist</span><span class="p">,</span> <span class="n">fixed_len</span><span class="o">=</span><span class="n">fixed_len</span><span class="p">,</span>
                                <span class="n">resampling</span><span class="o">=</span><span class="n">resampling</span><span class="p">)</span>

    <span class="n">B_ld</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">th_B</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="nb">len</span><span class="p">(</span><span class="n">th_B</span><span class="p">),</span> <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">num_workers</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
    <span class="n">simulate</span><span class="p">(</span><span class="n">B_ld</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">title</span> <span class="o">=</span> <span class="n">file_name</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0005.txt
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_16_1.png" src="../_images/Google_Colabs_Battery_SOH_K_means_16_1.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0006.txt
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_16_3.png" src="../_images/Google_Colabs_Battery_SOH_K_means_16_3.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0007.txt  (used in training)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_16_5.png" src="../_images/Google_Colabs_Battery_SOH_K_means_16_5.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0018.txt  (used in training)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_16_7.png" src="../_images/Google_Colabs_Battery_SOH_K_means_16_7.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0033.txt
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_16_9.png" src="../_images/Google_Colabs_Battery_SOH_K_means_16_9.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0034.txt  (used in training)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_16_11.png" src="../_images/Google_Colabs_Battery_SOH_K_means_16_11.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0036.txt  (used in training)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_16_13.png" src="../_images/Google_Colabs_Battery_SOH_K_means_16_13.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0041.txt
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_16_15.png" src="../_images/Google_Colabs_Battery_SOH_K_means_16_15.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0042.txt
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_16_17.png" src="../_images/Google_Colabs_Battery_SOH_K_means_16_17.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0043.txt
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_16_19.png" src="../_images/Google_Colabs_Battery_SOH_K_means_16_19.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0044.txt
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_16_21.png" src="../_images/Google_Colabs_Battery_SOH_K_means_16_21.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0045.txt  (used in training)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_16_23.png" src="../_images/Google_Colabs_Battery_SOH_K_means_16_23.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0046.txt  (used in training)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_16_25.png" src="../_images/Google_Colabs_Battery_SOH_K_means_16_25.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0047.txt
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_16_27.png" src="../_images/Google_Colabs_Battery_SOH_K_means_16_27.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0048.txt
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_16_29.png" src="../_images/Google_Colabs_Battery_SOH_K_means_16_29.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0053.txt  (used in training)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_16_31.png" src="../_images/Google_Colabs_Battery_SOH_K_means_16_31.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0054.txt  (used in training)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_16_33.png" src="../_images/Google_Colabs_Battery_SOH_K_means_16_33.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0055.txt
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_16_35.png" src="../_images/Google_Colabs_Battery_SOH_K_means_16_35.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0056.txt
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_16_37.png" src="../_images/Google_Colabs_Battery_SOH_K_means_16_37.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//&#39;</span> <span class="o">+</span> <span class="n">date</span><span class="p">)</span>  <span class="c1"># Entrando nele</span>
<span class="c1"># Loading the best epoch:</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Epochs&#39;</span><span class="p">)</span>
<span class="n">Best_Epoch_nb</span> <span class="o">=</span> <span class="p">(</span><span class="n">Training_info</span><span class="o">.</span><span class="n">best_epoch</span><span class="o">.</span><span class="n">nb</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span>
<span class="n">Model</span><span class="o">.</span><span class="n">load_state_dict</span><span class="p">(</span><span class="n">th</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="s1">&#39;Epoch_&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">Best_Epoch_nb</span><span class="p">)</span><span class="o">+</span><span class="s1">&#39;.txt&#39;</span><span class="p">))</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../&#39;</span><span class="p">)</span>
<span class="n">th</span><span class="o">.</span><span class="n">save</span><span class="p">(</span><span class="n">Model</span><span class="o">.</span><span class="n">state_dict</span><span class="p">(),</span> <span class="s1">&#39;FFNN_v1_Best_Epoch.txt&#39;</span><span class="p">)</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../&#39;</span><span class="p">)</span>
<span class="c1"># os.listdir()</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
[&#39;B0047.txt&#39;,
 &#39;B0050.txt&#39;,
 &#39;B0045.txt&#39;,
 &#39;B0053.txt&#39;,
 &#39;B0052.txt&#39;,
 &#39;B0051.txt&#39;,
 &#39;B0044.txt&#39;,
 &#39;B0046.txt&#39;,
 &#39;B0055.txt&#39;,
 &#39;B0041.txt&#39;,
 &#39;B0054.txt&#39;,
 &#39;B0040.txt&#39;,
 &#39;B0030.txt&#39;,
 &#39;B0043.txt&#39;,
 &#39;B0056.txt&#39;,
 &#39;B0042.txt&#39;,
 &#39;B0025.txt&#39;,
 &#39;B0033.txt&#39;,
 &#39;B0031.txt&#39;,
 &#39;B0026.txt&#39;,
 &#39;B0018.txt&#39;,
 &#39;B0027.txt&#39;,
 &#39;B0032.txt&#39;,
 &#39;B0036.txt&#39;,
 &#39;B0034.txt&#39;,
 &#39;B0005.txt&#39;,
 &#39;B0039.txt&#39;,
 &#39;B0038.txt&#39;,
 &#39;B0006.txt&#39;,
 &#39;B0049.txt&#39;,
 &#39;B0028.txt&#39;,
 &#39;B0007.txt&#39;,
 &#39;B0029.txt&#39;,
 &#39;B0048.txt&#39;,
 &#39;IVT_Data.txt&#39;,
 &#39;kmeans80.txt&#39;,
 &#39;train_dataset_FFNN.txt&#39;,
 &#39;train_dataset_FFNN2.txt&#39;,
 &#39;train_dataset_FFNN3_minmax.txt&#39;,
 &#39;.DS_Store&#39;,
 &#39;train_dataset_FFNN_zscore.txt&#39;,
 &#39;2021-06-01 10:34:42.291632&#39;,
 &#39;2021-06-01 10:33:15.597767&#39;,
 &#39;2021-06-01 10:35:10.858734&#39;,
 &#39;2021-06-01 10:30:45.544264&#39;,
 &#39;Epochs_LSTM_5&#39;,
 &#39;2021-06-01 11:06:17.899235&#39;,
 &#39;2021-06-01 10:58:31.278875&#39;,
 &#39;train_dataset_FFNN_norm_minmax.txt&#39;,
 &#39;2021-06-01 11:36:14.761573&#39;,
 &#39;train_dataset_FFNN_minmax.txt&#39;,
 &#39;2021-06-01 12:44:03.177432&#39;,
 &#39;2021-06-01 13:01:51.691022&#39;,
 &#39;2021-06-01 13:04:11.785755&#39;,
 &#39;2021-06-01 13:04:49.140320&#39;,
 &#39;2021-06-01 13:05:21.318494&#39;,
 &#39;2021-06-01 13:06:15.571733&#39;,
 &#39;2021-06-01 13:08:35.631437&#39;,
 &#39;2021-06-01 13:09:44.576416&#39;,
 &#39;2021-06-01 13:10:55.277624&#39;,
 &#39;2021-06-01 13:13:25.034874&#39;,
 &#39;2021-06-01 13:20:22.612001&#39;,
 &#39;2021-06-01 13:41:27.209961&#39;,
 &#39;2021-06-01 13:43:42.147376&#39;,
 &#39;2021-06-01 13:49:04.563965&#39;,
 &#39;2021-06-01 13:49:36.630394&#39;,
 &#39;2021-06-01 13:52:59.193753&#39;,
 &#39;2021-06-01 13:54:05.556663&#39;,
 &#39;train_dataset_FFNN_norm_zscore.txt&#39;,
 &#39;2021-06-01 13:56:31.682728&#39;,
 &#39;2021-06-01 14:02:08.228342&#39;,
 &#39;2021-06-01 14:03:07.305153&#39;,
 &#39;2021-06-01 14:04:13.417501&#39;,
 &#39;train_dataset_FFNN_norm_minmax_100.txt&#39;,
 &#39;2021-06-01 14:49:05.022281&#39;,
 &#39;train_dataset_FFNN_zscore_100.txt&#39;,
 &#39;2021-06-01 15:06:33.009373&#39;,
 &#39;2021-06-01 15:15:39.821156&#39;,
 &#39;2021-06-01 15:26:41.503313&#39;]
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="c1">#Name_list = [str(Battery.Name)+&#39;.txt&#39; for Battery in Train_list]</span>
<span class="n">Name_list</span> <span class="o">=</span> <span class="n">train</span>
<span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
    <span class="k">if</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">ignore</span><span class="p">:</span>
        <span class="k">continue</span>
    <span class="k">if</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">Name_list</span><span class="p">:</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39; (used in training)&#39;</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">file_name</span><span class="p">)</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>

    <span class="n">Battery_list</span> <span class="o">=</span> <span class="p">[</span><span class="n">Battery</span><span class="p">]</span>
    <span class="n">th_B</span> <span class="o">=</span> <span class="n">Torch_Dataset_KMEANS</span><span class="p">(</span><span class="n">Battery_list</span><span class="p">,</span> <span class="n">Nb_clusters</span><span class="p">,</span> <span class="n">kmeans</span><span class="o">=</span><span class="n">kmeans</span><span class="p">,</span>
                                <span class="n">print_bool</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">norm</span><span class="o">=</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">norm</span><span class="p">,</span>
                                <span class="n">mean_hist</span> <span class="o">=</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">mean_hist</span><span class="p">)</span>
    <span class="c1"># th_B = Torch_Dataset_KMEANS(Battery_list, Nb_clusters, kmeans=kmeans,</span>
    <span class="c1">#                         print_bool=False)</span>
    <span class="c1"># plt.plot(th_B.output)</span>
    <span class="c1"># plt.show()</span>
    <span class="n">B_ld</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">th_B</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="nb">len</span><span class="p">(</span><span class="n">th_B</span><span class="p">),</span> <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">num_workers</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
    <span class="n">simulate</span><span class="p">(</span><span class="n">B_ld</span><span class="p">,</span> <span class="n">Model</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0005.txt
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_18_1.png" src="../_images/Google_Colabs_Battery_SOH_K_means_18_1.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0006.txt
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_18_3.png" src="../_images/Google_Colabs_Battery_SOH_K_means_18_3.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0007.txt  (used in training)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_18_5.png" src="../_images/Google_Colabs_Battery_SOH_K_means_18_5.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0018.txt  (used in training)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_18_7.png" src="../_images/Google_Colabs_Battery_SOH_K_means_18_7.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0033.txt
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_18_9.png" src="../_images/Google_Colabs_Battery_SOH_K_means_18_9.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0034.txt  (used in training)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_18_11.png" src="../_images/Google_Colabs_Battery_SOH_K_means_18_11.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0036.txt  (used in training)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_18_13.png" src="../_images/Google_Colabs_Battery_SOH_K_means_18_13.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0041.txt
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_18_15.png" src="../_images/Google_Colabs_Battery_SOH_K_means_18_15.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0042.txt
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_18_17.png" src="../_images/Google_Colabs_Battery_SOH_K_means_18_17.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0043.txt
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_18_19.png" src="../_images/Google_Colabs_Battery_SOH_K_means_18_19.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0044.txt
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_18_21.png" src="../_images/Google_Colabs_Battery_SOH_K_means_18_21.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0045.txt  (used in training)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_18_23.png" src="../_images/Google_Colabs_Battery_SOH_K_means_18_23.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0046.txt  (used in training)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_18_25.png" src="../_images/Google_Colabs_Battery_SOH_K_means_18_25.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0047.txt
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_18_27.png" src="../_images/Google_Colabs_Battery_SOH_K_means_18_27.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0048.txt
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_18_29.png" src="../_images/Google_Colabs_Battery_SOH_K_means_18_29.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0053.txt  (used in training)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_18_31.png" src="../_images/Google_Colabs_Battery_SOH_K_means_18_31.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0054.txt  (used in training)
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_18_33.png" src="../_images/Google_Colabs_Battery_SOH_K_means_18_33.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0055.txt
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_18_35.png" src="../_images/Google_Colabs_Battery_SOH_K_means_18_35.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
B0056.txt
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_18_37.png" src="../_images/Google_Colabs_Battery_SOH_K_means_18_37.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-python notranslate"><div class="highlight"><pre>
<span></span><span class="n">list_run</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;B0038.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0039.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0040.txt&#39;</span><span class="p">]</span>

<span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">list_run</span><span class="p">:</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>

    <span class="n">Battery_list</span> <span class="o">=</span> <span class="p">[</span><span class="n">Battery</span><span class="p">]</span>
    <span class="n">th_B</span> <span class="o">=</span> <span class="n">Torch_Dataset_KMEANS</span><span class="p">(</span><span class="n">Battery_list</span><span class="p">,</span> <span class="n">Nb_clusters</span><span class="p">,</span> <span class="n">kmeans</span><span class="o">=</span><span class="n">kmeans</span><span class="p">,</span>
                                <span class="n">print_bool</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">norm</span><span class="o">=</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">norm</span><span class="p">,</span>
                                <span class="n">mean_hist</span> <span class="o">=</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">mean_hist</span><span class="p">)</span>
    <span class="c1"># th_B = Torch_Dataset_KMEANS(Battery_list, Nb_clusters, kmeans=kmeans,</span>
    <span class="c1">#                         print_bool=False)</span>
    <span class="c1"># plt.plot(th_B.output)</span>
    <span class="c1"># plt.show()</span>
    <span class="n">B_ld</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">th_B</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="nb">len</span><span class="p">(</span><span class="n">th_B</span><span class="p">),</span> <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">num_workers</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
    <span class="n">simulate</span><span class="p">(</span><span class="n">B_ld</span><span class="p">,</span> <span class="n">Model</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_19_0.png" src="../_images/Google_Colabs_Battery_SOH_K_means_19_0.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_19_1.png" src="../_images/Google_Colabs_Battery_SOH_K_means_19_1.png" />
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../_images/Google_Colabs_Battery_SOH_K_means_19_2.png" src="../_images/Google_Colabs_Battery_SOH_K_means_19_2.png" />
</div>
</div>
</div>


              </div>
              
              
              <div class='prev-next-bottom'>
                

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2021, Antonio Rocha Azevedo.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>